freeslot("MT_BUILDSENTRY","MT_BUILDGUARD","MT_BUILDSPRING")
freeslot("MT_BUILDINGBOX","SPR_BBOX","S_BUILD_BOX", "S_BUILD_FLASH", "S_BUILD_USED", "S_BUILD_ICON","SPR_BCON")
states[S_BUILD_BOX] = {SPR_BBOX,A,3,nil,0,0,S_BUILD_FLASH}
states[S_BUILD_FLASH] = {SPR_BBOX,B,2,nil,0,0,S_BUILD_BOX}

states[S_BUILD_USED] = {SPR_BBOX,C,TICRATE*2,nil,0,0,S_NULL}
states[S_BUILD_ICON] = {SPR_BCON,D,2,nil,0,0,S_NULL}

mobjinfo[MT_BUILDINGBOX] = {
	-1,            // doomednum
	S_BUILD_BOX,     // spawnstate
	1,              // spawnhealth
	S_BUILD_FLASH,         // seestate
	sfx_None,       // seesound
	8,              // reactiontime
	sfx_None,       // attacksound
	S_BUILD_BOX,     // painstate
	0,              // painchance
	sfx_None,       // painsound
	S_NULL,         // meleestate
	S_NULL,         // missilestate
	S_BUILD_USED,     // deathstate
	S_NULL,         // xdeathstate
	sfx_pop,        // deathsound
	1,              // speed
	18*FRACUNIT,    // radius
	40*FRACUNIT,    // height
	0,              // display offset
	100,            // mass
	S_BUILD_ICON,   // damage
	sfx_None,       // activesound
	MF_SHOOTABLE, // flags
	S_NULL          // raisestate
}
rawset(_G,"IsBuilding",function(mo)
	if mo.type == MT_BUILDSENTRY
		return 1
	end
	if mo.type == MT_BUILDGUARD
	or mo.type == MT_BUILDSHIELD
		return 2
	end
	if mo.type == MT_BUILDSPRING
		return 3
	end
	return 0
end)

local buildcost = {
[1] = 40,
[2] = 20,
[3] = 10}
local bosscost = {
[1] = 8,
[2] = 2,
[3] = 0}
addHook("PlayerThink", function(player)
	if player.valid --Extra stuff
	and player.charability2 == CA2_WRENCH
		local bcost = (mapheaderinfo[gamemap].bonustype == 1) and bosscost or buildcost
	
		player.bchs = $ or 1
		player.bcd = $ or 0
		if player.bcd player.bcd = $-1 end
		
		player.bpdah = $ or 0
		player.bpdam = $ or 0
		if player.godown
			player.bpdam = $+1
			if (player.bpdah+player.bpdam) < 0
				player.bpdah = $+player.bpdam
			else
				player.bpdah = 0
			end
		end
		if player.goup
			player.bpdam = $+1
			if (player.bpdah-player.bpdam) > -48
				player.bpdah = $-player.bpdam
			else
				player.bpdah = -48
			end
		end
		if player.cmd.buttons & BT_CUSTOM1
			if not player.dodathing
			and player.bpda
			and not player.bcd
				player.bpda = false
				player.bcd = 15
				player.godown = true
				player.goup = false
				player.bpdam = 0
			end
			if not player.dodathing
			and not player.bpda
			and not player.bcd
				player.bchs = 1
				player.bpda = true
				player.bcd = 15
				player.goup = true
				player.godown = false
				player.bpdam = 0
			end
			player.dodathing = true
		else
			player.dodathing = false
		end
		
		if not player.builds
			player.builds = {}
		end
		if player.bpda
			if player.cmd.buttons & BT_WEAPONNEXT
				if player.bchs < 3
					player.bchs = $+1
				end
				player.bn = true
			else
				player.bn = false
			end
			if player.cmd.buttons & BT_WEAPONPREV
				if player.bchs > 1
					player.bchs = $-1
				end
				player.bp = true
			else
				player.bp = false
			end
			
			local function BuildExits(player)
				if player.bchs == 1
				and player.builds.sentry and player.builds.sentry.valid
					return player.builds.sentry
				end
				if player.bchs == 2
				and player.builds.shield and player.builds.shield.valid
					return player.builds.shield
				end
				if player.bchs == 3
				and player.builds.spring and player.builds.spring.valid
					return player.builds.spring
				end
				return false
			end
			
			if player.cmd.buttons & BT_CUSTOM2
				if not player.bc2
					if not BuildExits(player)
					and player.rings
					and player.rings >= bcost[player.bchs]
						player.rings = $-bcost[player.bchs]
					
						local building = {
						[1] = MT_BUILDSENTRY,
						[2] = MT_BUILDGUARD,
						[3] = MT_BUILDSPRING}
						
						
						local b = P_SpawnMobjFromMobj(player.mo,0,0,player.mo.height/2,MT_BUILDINGBOX)
						b.momx = player.mo.momx
						b.momy = player.mo.momy
						b.momz = player.mo.momz
						P_SetObjectMomZ(b,6*FRACUNIT,true)
						P_Thrust(b,player.mo.angle,4*FRACUNIT)
						b.tracer = player.mo
						b.angle = player.mo.angle
						b.color = player.mo.color
						if building[player.bchs]
							b.build = building[player.bchs]
						else
							b.build = MT_RING_BOX
						end
						b.buildstuff = TICRATE
						if player.bchs == 1
							player.builds.sentry = b
							b.runtime = TICRATE*30
							b.setobj = "sentry"
						elseif player.bchs == 2
							player.builds.shield = b
							b.setobj = "shield"
						elseif player.bchs == 3
							player.builds.spring = b
							b.angle = $+ANGLE_180
							b.runtime = TICRATE*15
							b.setobj = "spring"
						end
					else
						local b = BuildExits(player)
						if b and b.valid
						and b.type != MT_BUILDINGBOX
							P_DamageMobj(b,nil,nil,16,DMG_INSTAKILL)
						end
					end
					
					player.bpda = false
					player.bcd = 15
					player.godown = true
					player.goup = false
					player.bpdam = 0
				end
				player.bc2 = true
			else
				player.bc2 = false
			end
		end
		if player.builds
			if player.builds.sentry
			and player.builds.sentry.valid
				local w = player.builds.sentry
				if w.target and w.target.valid
				and w.target.health
					P_SpawnLockOn(player,w.target,S_LOCKON1)
				end
			end
		end
		player.hadwrench = true
	end
	if player.valid
	and player.charability2 != CA2_WRENCH
		if player.hadwrench
		and player.builds
			for i,k in pairs(player.builds)
				local b = player.builds[i]
				if b and b.valid
				and b.type != MT_BUILDINGBOX
					b.shieldhealth = 0
					P_DamageMobj(b,nil,nil,16,DMG_INSTAKILL)
				end
			end
		end
		player.hadwrench = false
	end
end)
addHook("MobjThinker", function(mo)
	if mo and mo.valid
		local buildtoframe = {
		[MT_BUILDSENTRY] = A,
		[MT_BUILDGUARD] = B,
		[MT_BUILDSPRING] = C}
		
		mo.buildstuff = $ or 0
		if mo.buildstuff
			mo.spriteyscale = (FRACUNIT+FRACUNIT/3)-FixedMul(FRACUNIT/2,sin(mo.buildstuff*ANG1))
			mo.spritexscale = (FRACUNIT-FRACUNIT/3)+FixedMul(FRACUNIT/2,sin(mo.buildstuff*ANG1))
			mo.buildstuff = $-1
			if mo.tracer and mo.tracer.valid
				mo.color = mo.tracer.color
			end
			if mo.build and mo.state == S_BUILD_BOX
				local o = P_SpawnMobjFromMobj(mo,0,0,0,MT_OVERLAY)
				o.state = S_BUILD_ICON
				o.target = mo
				o.color = mo.color
				o.spriteyscale = mo.spriteyscale
				o.spritexscale = mo.spritexscale
				if mo.build == MT_BUILDSENTRY
					o.frame = buildtoframe[MT_BUILDSENTRY]
				elseif mo.build == MT_BUILDGUARD
					o.frame = buildtoframe[MT_BUILDGUARD]
				elseif mo.build == MT_BUILDSPRING
					o.frame = buildtoframe[MT_BUILDSPRING]
				end
			end
			mo.yeahimma = true
		elseif mo.yeahimma
			S_StartSound(mo,mo.info.deathsound)
			mo.spriteyscale = FRACUNIT
			mo.spritexscale = FRACUNIT
			
			local p = P_SpawnMobjFromMobj(mo,0,0,0,MT_EXPLODE)
			p.scale = mo.scale/2*3
			mo.state = mo.info.deathstate
			if mo.build
			and mo.tracer and mo.tracer.valid
				local t = mo.tracer
				local b = P_SpawnMobjFromMobj(mo,0,0,0,mo.build)
				b.tracer = t
				b.color = t.color
				b.angle = mo.angle
				b.shieldhealth = 10
				if mo.runtime
					b.runtime = mo.runtime
				end
				if t.player and t.player.valid
				and mo.setobj
					if mo.setobj == "sentry"
						t.player.builds.sentry = b
					elseif mo.setobj == "shield"
						t.player.builds.shield = b
					elseif mo.setobj == "spring"
						t.player.builds.spring = b
					end
				end
			end
			mo.yeahimma = false
			
			local fa = P_RandomRange(0,360)*ANG1
			local zfa = P_RandomRange(90,0)*ANG1
			local minf = 10*FRACUNIT
			local maxf = 24*FRACUNIT
			local force = P_RandomRange(minf>>FRACBITS,maxf>>FRACBITS)<<FRACBITS
			P_InstaThrust(mo,fa,FixedMul(cos(zfa),force))
			P_SetObjectMomZ(mo,FixedMul(sin(zfa),force))
			mo.ranflip = P_RandomRange(0,1)
		end
		
		if mo.state == mo.info.deathstate
			if not P_IsObjectOnGround(mo)
				local fl = 1
				if mo.ranflip
					fl = -1
				end
				mo.rollangle = $+abs(FixedAngle(mo.momz*fl))
				if mo.fuse < TICRATE
					mo.fuse = TICRATE
				end
			else
				if abs(mo.rollangle) >= ANGLE_90
					mo.rollangle = ANGLE_180
				else
					mo.rollangle = 0
				end
			end
		end
	end
end,MT_BUILDINGBOX)
addHook("MobjFuse", function(mo)
	if mo and mo.valid
		local g = P_SpawnGhostMobj(mo)
		g.scale = mo.scale
		g.momx = mo.momx
		g.momy = mo.momy
		g.momz = mo.momz
		g.rollangle = mo.rollangle
		g.spritexscale = mo.spritexscale
		g.spriteyscale = mo.spriteyscale
	end
end,MT_BUILDINGBOX)

addHook("HUD", function(v,player,cam) --Extra stuff
	if player.valid
	and player.charability2 == CA2_WRENCH
		local bcost = (mapheaderinfo[gamemap].bonustype == 1) and bosscost or buildcost
	
		local r = 0
		local f4 = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS
		local l = hudinfo[HUD_LIVES]
		local x = hudinfo[HUD_LIVES].x+8
		local y = hudinfo[HUD_LIVES].y-3
		if player.rings
			r = player.rings
		end
		if not hud.enabled("lives")
			y = $+16
		end
		local f3 = 0
		if (leveltime%23) >= 12
			f3 = V_FLIP
		end
		local sr = v.getSpritePatch(SPR_SCRG,leveltime%23,0,0)
		if sr
			v.drawScaled(x*FRACUNIT,y*FRACUNIT,FRACUNIT/2,sr,f4|f3)
			v.draw(x+10,y-5,v.cachePatch("STLIVEX"),f4)
			v.drawString(x+20,y-7,r,f4)
		end
		if player.bpdah
			local f = V_SNAPTOBOTTOM|V_HUDTRANS|V_PERPLAYER
			local bc = v.cachePatch("BUILDCBLU")
			local b = v.cachePatch("BUILDBLU")
			local br = v.cachePatch("SCRAPRING")
			local bd = 43 --Width of the graphics so that it would align properly
			local by = 0
			if player.bpdah --Stuff so it would slide up and down
				by = player.bpdah
			end
			
			local function AddRed(player)
				local bruh = {}
				bruh[1] = 0
				bruh[2] = 0
				bruh[3] = 0
				bruh[4] = 0
				if player.builds
					if player.builds.sentry and player.builds.sentry.valid
						bruh[1] = 1
					end
					if player.builds.shield and player.builds.shield.valid
						bruh[2] = 1
					end
					if player.builds.spring and player.builds.spring.valid
						bruh[3] = 1
					end
				end
				return bruh
			end
			
			local x = 160
			local y = 248+by
			if player.bchs --When choosing overlay
				if AddRed(player)
				and AddRed(player)[player.bchs]
					bc = v.cachePatch("BUILDCRED")
				end
				v.draw(x+(bd*(player.bchs-2)),y,bc,f)
				
				if AddRed(player)
				and AddRed(player)[player.bchs]
					local y2 = -46
					if player.bchs == 1
					and player.builds.sentry and player.builds.sentry.valid
						local time = 0
						local f2 = 0
						if player.builds.sentry.runtime
							time = G_TicsToSeconds(player.builds.sentry.runtime)
						end
						if time <= 5
							if (leveltime%10) <= 4
								f2 = $|V_REDMAP
							else
								f2 = $&~V_REDMAP
							end
						end
						v.drawString(x+(bd*(player.bchs-2)),y+y2,time,f|f2,"center")
					end
					
					if player.bchs == 2
					and player.builds.shield and player.builds.shield.valid
						local hits = 10
						local f2 = 0
						if player.builds.shield.shieldhealth
							hits = player.builds.shield.shieldhealth
						end
						if hits <= 1
							if (leveltime%10) <= 4
								f2 = $|V_REDMAP
							else
								f2 = $&~V_REDMAP
							end
						end
						v.drawString(x+(bd*(player.bchs-2)),y+y2,hits,f|f2,"center")
					end
					
					if player.bchs == 3
					and player.builds.spring and player.builds.spring.valid
						local time = 0
						local f2 = 0
						if player.builds.spring.runtime
							time = G_TicsToSeconds(player.builds.spring.runtime)
						end
						if time <= 5
							if (leveltime%10) <= 4
								f2 = $|V_REDMAP
							else
								f2 = $&~V_REDMAP
							end
						end
						v.drawString(x+(bd*(player.bchs-2)),y+y2,time,f|f2,"center")
					end
				end
			end
			v.draw(x,y,b,f) --The icons
			
			local redover = {
			[1] = "BUILDSRED",
			[2] = "BUILDHRED",
			[3] = "BUILDPRED"}
			if AddRed(player) --Red overlay
				for i = -1,1
					local rb = v.cachePatch(redover[i+2])
					local reb = AddRed(player)
					if reb[i+2] and reb[i+2] == 1
						v.draw(x+(bd*i),y,rb,f)
					end
				end
			end
			
			for i = -1,1 --Scrap ring cost
				local f5 = 0
				local shifti = i+2
				if bcost and bcost[shifti]
					v.draw(x+(bd*i),y,br,f)
					if r < bcost[shifti]
						f5 = V_REDMAP
					end
					v.drawString(x-5+(bd*i),y-10,bcost[shifti],f|f5)
				end
			end
		end
	end
end,"game")