//Jetty-sentry building.

freeslot("MT_BUILDSENTRY","SPR_BSEN")
freeslot("S_BSEN_FLOAT1", "S_BSEN_FLOAT2","S_BSEN_FIRE1","S_BSEN_FIRE2")

rawset(_G, "CheckPlayer", function(m1, m2,bruh) --1 = builder, 2 = whos about to get 0%`d
	if m1 and m1.valid
	and m2 and m2.valid
	and m1.player and m1.player.valid
	and m2.player and m2.player.valid
		local p1 = m1.player
		local p2 = m2.player
		if (gametyperules & GTR_FRIENDLY)
			if friendlyfire or (gametyperules & GTR_FRIENDLYFIRE)
				return false
			else
				return true
			end
		else
			if (gametyperules & GTR_TEAMS)
				if friendlyfire or (gametyperules & GTR_FRIENDLYFIRE)
					return false
				else
					if p1.ctfteam and p2.ctfteam
					and p1.ctfteam == p2.ctfteam
						return true
					else
						return false
					end
				end
			else
				return false
			end
		end
	end
	return false
end)
rawset(_G,"SearchForShootables",function(m) --P_LookForEnemies (Edited)
	if m and m.valid
		local closestmo = nil
		local maxdist = 3074*FRACUNIT
		local span = ANGLE_90
		local dist
		local closestdist
		for mo in mobjs.iterate()
			if mo and mo.valid
				if (mo.flags & MF_NOCLIPTHING) continue end
				if mo.health <= 0 continue end
				if (mo.flags & (MF_MONITOR|MF_MISSILE)) continue end
				if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_SHOOTABLE)) continue end
				if mo == m continue end
				if mo.flags2 & MF2_FRET continue end
				
					local zdist = (m.z+m.height/2)-(mo.z+mo.height/2)
					dist = R_PointToDist2(mo.x,mo.y,m.x,m.y)
					
					dist = R_PointToDist2(0,dist,0,zdist)
					if dist > maxdist continue end
					
				if ((twodlevel or m.flags2 & MF2_TWOD)
				and abs(m.y-mo.y) > m.radius) continue end
				
				if m.tracer and m.tracer.valid
					if mo == m.tracer continue end
					if mo.tracer and mo.tracer.valid
					and mo.tracer == m.tracer continue end
					if mo.player and mo.player.valid
						if CheckPlayer(m.tracer, mo) continue end
					end
				end
				
				if (closestmo and dist > closestdist) continue end
				if abs(R_PointToAngle2(m.x,m.y,mo.x,mo.y)-m.angle) > span
					continue
				end
				
				if not P_CheckSight(m,mo) continue end
				
				closestmo = mo
				closestdist = dist
			end
		end
		return closestmo
	end
end)

states[S_BSEN_FLOAT1] = {SPR_BSEN, A, 2,nil,0,0,S_BSEN_FLOAT2}
states[S_BSEN_FLOAT2] = {SPR_BSEN, B, 2,nil,0,0,S_BSEN_FLOAT1}

states[S_BSEN_FIRE1] = {SPR_BSEN, C, 2,nil,0,0,S_BSEN_FIRE2}
states[S_BSEN_FIRE2] = {SPR_BSEN, D, 2,nil,0,0,S_BSEN_FLOAT1}
mobjinfo[MT_BUILDSENTRY] = {
	-1,              // doomednum
	S_BSEN_FLOAT1,    // spawnstate
	2,                // spawnhealth
	S_BSEN_FLOAT2,    // seestate
	sfx_None,         // seesound
	25,               // reactiontime
	sfx_s3k4d,        // attacksound
	S_BSEN_FLOAT1,    // painstate
	3072,             // painchance
	sfx_cybdth,       // painsound
	S_NULL,           // meleestate
	S_BSEN_FIRE1,     // missilestate
	S_XPLD1,  		  // deathstate
	S_NULL,           // xdeathstate
	sfx_pop,          // deathsound
	FRACUNIT,     	  // speed
	20*FRACUNIT,      // radius
	48*FRACUNIT,      // height
	0,                // display offset
	100,              // mass
	0,                // damage
	sfx_None,         // activesound
	MF_SLIDEME|MF_SPECIAL|MF_SHOOTABLE|MF_NOGRAVITY, // flags
	MT_JETTBULLET     // raisestate
}
local function MoveTo(actor,x,y,z)
	local thefloor

	if (actor.flags2 & MF2_AMBUSH)
		return
	end
	
	if (actor.z >= actor.waterbottom and actor.watertop > actor.floorz
	and actor.z > actor.watertop - FixedMul(256*FRACUNIT, actor.scale))
		thefloor = actor.watertop
	else
		thefloor = actor.floorz
	end

	if (actor.reactiontime)
		actor.reactiontime = $-1
	end

	if (P_RandomChance(FRACUNIT/32))
		actor.momx = actor.momx/2
		actor.momy = actor.momy/2
		actor.momz = actor.momz/2
	end

	// Bounce if too close to floor or ceiling -
	// ideal for Jetty-Syns above you on 3d floors
	if (actor.momz and ((actor.z - FixedMul((32<<FRACBITS), actor.scale)) < thefloor) and not ((thefloor + FixedMul(32*FRACUNIT, actor.scale) + actor.height) > actor.ceilingz))
		actor.momz = -actor.momz/2
	end

	// modify target threshold
	if (actor.threshold)
		if (not who or who.health <= 0)
			actor.threshold = 0
		else
			actor.threshold = $-1
		end
	end

	// turn towards movement direction if not there yet
	local diff = (R_PointToAngle2(actor.x, actor.y, x, y)-actor.angle)
	local factor = 8
	if diff
		if diff > ANGLE_180 diff = InvAngle(InvAngle($)/factor)
		else diff = $/factor end
		actor.angle = $+diff
	end

	/*
	// If the player is over 3072 fracunits away, then look for another player
	if (P_AproxDistance(P_AproxDistance(x - actor.x, y - actor.y),
		z - actor.z) > FixedMul(3072*FRACUNIT, actor.scale))
		
		return // got a new target
	end*/

	// chase towards player
	P_Thrust(actor, actor.angle, FixedMul(actor.info.speed/4, actor.scale))

	// must adjust height
	if (actor.z < (z + FixedMul((32<<FRACBITS), actor.scale)))
		actor.momz = $+FixedMul(FRACUNIT/2, actor.scale)
	else
		actor.momz = $-FixedMul(FRACUNIT/2, actor.scale)
	end
end
addHook("MobjThinker", function(mo) --Main thinker
	if mo and mo.valid
	and mo.health
		mo.shootcd = $ or 25
		if not mo.faint
			if mo.target and mo.target.valid
				local t = mo.target
				MoveTo(mo,t.x,t.y,t.z+t.height/2)
				if mo.shootcd
					if mo.shootcd == 25
						mo.state = mo.info.missilestate
						P_SpawnXYZMissile(mo,t,mo.info.raisestate,mo.x,mo.y,mo.z+mo.height/2)
						S_StartSound(mo,mo.info.attacksound)
					end
					mo.shootcd = $-1
				end
				
			elseif mo.tracer and mo.tracer.valid
				local c = mo.tracer
				local az = c.height
				if P_MobjFlip(c) == -1 az = 0 end
				MoveTo(mo,c.x,c.y,c.z+az)
			else
				MoveTo(mo,mo.x,mo.y,mo.floorz+100*FRACUNIT)
			end
			local f = SearchForShootables(mo)
			if f and f.valid
			and f.health
				mo.target = f
			end
		else
			mo.target = nil
		end
		if not mo.target
			mo.shootcd = 0
		end
		if mo.tracer and mo.tracer.valid
			mo.color = mo.tracer.color
		end
		mo.flashing = $ or 0
		if mo.flashing
		and mo.health
			mo.flashing = $-1
			if (mo.flashing&1)
				mo.colorized = true
				
				local g = P_SpawnGhostMobj(mo) --Colorized flashing can be unnoticable
				g.fuse = 3
				g.colorized = true
				g.color = SKINCOLOR_DAMAGED
				g.scale = mo.scale
				g.destscale = mo.scale/2*3
			else
				mo.colorized = false
			end
			mo.stopflash = true
		elseif mo.stopflash
			mo.flashing = 0
			mo.colorized = false
			mo.stopflash = false
		end
		if (mo.health and mo.health <= mo.info.spawnhealth/2)
		or mo.faint
			local chance = FRACUNIT/10
			if mo.faint
				chance = FRACUNIT/5
			end
			if P_RandomChance(chance)
				local ranr = P_RandomRange(0,mo.radius>>FRACBITS)<<FRACBITS
				local rana = P_RandomRange(0,360)*ANG1
				local ranx = P_ReturnThrustX(nil,rana,ranr)
				local rany = P_ReturnThrustY(nil,rana,ranr)
				local ranz = P_RandomRange(0,mo.height>>FRACBITS)<<FRACBITS
				
				local d = P_SpawnMobjFromMobj(mo,ranx,rany,ranz, MT_SMOKE)
				P_SetObjectMomZ(d,3*FRACUNIT)
				S_StartSound(mo, sfx_kc2a)
				if mo.tracer and mo.tracer.valid --So that the owner of the sentry can always hear it smoking
				and mo.tracer.player and mo.tracer.player.valid --Like in TF2 when sentry is low on health you can hear beeps.
					S_StartSoundAtVolume(mo.tracer,sfx_kc2a,75,mo.tracer.player) 
				end
			end
		end
		
		if mo.runtime
			mo.runtime = $-1
			mo.paindeed = true
		elseif mo.paindeed
			mo.faint = true
			mo.ranflip = P_RandomRange(0,1)
			mo.flags = $&~MF_NOGRAVITY
			mo.paindeed = false
		end
		if mo.faint
			if not P_IsObjectOnGround(mo)
				local fl = 1
				if mo.ranflip
					fl = -1
				end
				mo.rollangle = $+abs(FixedAngle(mo.momz*fl))
			else
				P_DamageMobj(mo,nil,nil,1,DMG_INSTAKILL)
			end
		end
	end
end, MT_BUILDSENTRY)

addHook("TouchSpecial", function(mo,mobj) --Damage fixes
	if mo and mo.valid
		if mobj and mobj.valid
		and mobj.player and mobj.player.valid
		and P_PlayerCanDamage(mobj.player,mo)
			if not mo.flashing
				P_DamageMobj(mo,mobj,mobj,1)
				mo.flashing = 25
				mobj.momx = -$
				mobj.momy = -$
				mobj.momz = -$
			end
		end
		return true
	end
end, MT_BUILDSENTRY)
local DMG_SENTRY = 7
addHook("MobjDamage", function(mo,mobj,src,dmg,dmgtype)
	if mo and mo.valid
		if mobj and mobj.valid
		and mobj.type == mobjinfo[MT_BUILDSENTRY].raisestate
		and mobj.target and mobj.target.valid
		and dmgtype != DMG_SENTRY
			local m = mobj.target
			if m.tracer and m.tracer.valid
			and m.type == MT_BUILDSENTRY
				P_DamageMobj(mo,mobj,m.tracer,1,DMG_SENTRY)
				return true
			end
		end
	end
end)