//Spring-bot building.

freeslot("MT_BUILDSPRING","SPR_BLDS")
freeslot("S_BSPRING_STND")
for i = 1, 4
	freeslot("S_BSPRING_RUN"..i,"S_BSPRING_SPRING"..i)
end

states[S_BSPRING_STND] = {SPR_BLDS,A,5,nil,0,0,S_BSPRING_STND}

states[S_BSPRING_RUN1] = {SPR_BLDS,A,5,nil,0,0,S_BSPRING_RUN2}
states[S_BSPRING_RUN2] = {SPR_BLDS,B,5,nil,0,0,S_BSPRING_RUN3}
states[S_BSPRING_RUN3] = {SPR_BLDS,C,5,nil,0,0,S_BSPRING_RUN4}
states[S_BSPRING_RUN4] = {SPR_BLDS,D,5,nil,0,0,S_BSPRING_RUN1}

states[S_BSPRING_SPRING1] = {SPR_BLDS,7,5,nil,0,0,S_BSPRING_SPRING2}
states[S_BSPRING_SPRING2] = {SPR_BLDS,6,2,nil,0,0,S_BSPRING_SPRING3}
states[S_BSPRING_SPRING3] = {SPR_BLDS,5,2,nil,0,0,S_BSPRING_SPRING4}
states[S_BSPRING_SPRING4] = {SPR_BLDS,4,2,nil,0,0,S_BSPRING_STND}

mobjinfo[MT_BUILDSPRING] = {
	-1,             // doomednum
	S_BSPRING_STND, // spawnstate
	1,              // spawnhealth
	S_BSPRING_RUN1,  // seestate
	sfx_None,       // seesound
	32,             // reactiontime
	sfx_None,       // attacksound
	S_NULL,         // painstate
	0,              // painchance
	sfx_spring,     // painsound
	S_NULL,         // meleestate
	S_NULL,         // missilestate
	S_XPLD1,  		// deathstate
	S_NULL,         // xdeathstate
	sfx_pop,        // deathsound
	16*FRACUNIT,    // speed
	24*FRACUNIT,    // radius
	40*FRACUNIT,    // height
	0,              // display offset
	15*FRACUNIT,    // mass
	0,              // damage
	sfx_None,       // activesound
	MF_SPECIAL|MF_SHOOTABLE, // flags
	S_BSPRING_SPRING1// raisestate
}

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.health
		if mo.tracer and mo.tracer.valid
			mo.color = mo.tracer.color
		end
	
		mo.flashing = $ or 0
		if mo.flashing
		and mo.health
			mo.flashing = $-1
			if (mo.flashing&1)
				mo.colorized = true
				
				local g = P_SpawnGhostMobj(mo) --Colorized flashing can be unnoticable
				g.fuse = 3
				g.colorized = true
				g.color = SKINCOLOR_DAMAGED
				g.scale = mo.scale
				g.destscale = mo.scale/2*3
			else
				mo.colorized = false
			end
			mo.stopflash = true
		elseif mo.stopflash
			mo.flashing = 0
			mo.colorized = false
			mo.stopflash = false
		end
		
		if mo.runtime
			mo.runtime = $-1
			mo.paindeed = true
		elseif mo.paindeed
			mo.faint = true
			mo.goto = mo.angle+ANGLE_180
			mo.paindeed = false
		end
		if mo.faint
			if mo.goto
				if mo.state == S_BSPRING_STND
					mo.state = S_BSPRING_RUN1
				end
				local diff = (mo.goto-mo.angle)
				local factor = 4
				if diff
					if abs(diff) > ANG15 --Dorifto
						local dashspeed = R_PointToDist2(0,0,mo.momx,mo.momy)
						local ang = mo.angle
						for i = 1, (leveltime%7)/2
							local p = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SPINDUST)
							if mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER)
								p.state = S_SPINDUST_BUBBLE1
							end
							p.target = mo
							p.scale = (2*mo.scale)/3
							if P_MobjFlip(mo) == -1
								P_ChangeOrigin(p, p.x, p.y, mo.z+mo.height-p.height,true)
							end
							local pr = {}
							pr[0] = P_RandomFixed()<<2
							pr[1] = P_RandomRange(-30, 30)
							pr[2] = P_RandomFixed()<<3
							P_SetObjectMomZ(p, dashspeed/50+pr[0], false)
							P_InstaThrust(p,
								ang + (pr[1]*ANG1),
								-FixedMul(dashspeed/12+FRACUNIT+pr[2], mo.scale))
							P_TryMove(p, p.x+p.momx, p.y+p.momy, true)
						end
					end
					if (diff > ANGLE_180)
						diff = InvAngle(InvAngle($)/factor)
					else
						diff = $/factor
					end
					mo.angle = $+diff
				end
			end
			P_Thrust(mo,mo.angle,(mo.info.speed-R_PointToDist2(0,0,mo.momx,mo.momy))/4)
		end
	end
end,MT_BUILDSPRING)

addHook("MobjMoveBlocked", function(mo)
	if mo and mo.valid
	and mo.health
	and mo.faint
		P_DamageMobj(mo,nil,nil,1,DMG_INSTAKILL)
	end
end,MT_BUILDSPRING)

addHook("TouchSpecial", function(mo,mobj) --Damage fixes
	if mo and mo.valid
		if mobj and mobj.valid
			local tmz = mobj.z
			local tmznext = mobj.momz + tmz
			local thzh = mo.z + mo.height
			local sprarea = FixedMul(8*FRACUNIT, mo.scale)*P_MobjFlip(mo)
			if (mo.eflags & MFE_VERTICALFLIP)
				tmz = -(mobj.z + mobj.height)
				tmznext = -mobj.momz + tmz
				thzh = -mo.z
			end
			if ((tmznext <= thzh and tmz > thzh) or (tmznext > thzh - sprarea and tmznext < thzh))
				S_StartSound(mo,mo.info.painsound)
				P_DoSpring(mo,mobj)
				mo.runtime = TICRATE*15 --Reset timer when used.
				return true
			end
		end
		if mobj and mobj.valid
		and mobj.player and mobj.player.valid
		and P_PlayerCanDamage(mobj.player,mo)
			if not mo.flashing
			and CheckPlayer(mo.tracer, mobj)
				P_DamageMobj(mo,mobj,mobj,1)
			end
		end
		return true
	end
end, MT_BUILDSPRING)