freeslot("SKINCOLOR_DAMAGED","SPR_DMGN","S_DAMAGE_25","S_DAMAGE_50")
states[S_DAMAGE_25] = {SPR_DMGN,A|FF_FULLBRIGHT,TICRATE,nil,0,0,S_NULL}
states[S_DAMAGE_50] = {SPR_DMGN,B|FF_FULLBRIGHT,TICRATE,nil,0,0,S_NULL}
skincolors[SKINCOLOR_DAMAGED] = {
	name = "damage",
	ramp = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	invcolor = SKINCOLOR_DAMAGED,
	invshade = 1,
	chatcolor = V_GREYMAP,
	accessible = false
}

local function DoHPCheck(mo, checkhp)
	if not mo.health and checkhp
		return false
	end
	if (mo.flags & (MF_ENEMY|MF_BOSS))
	and (mo.flags & MF_SHOOTABLE)
	and not (mo.flags & (MF_MONITOR|MF_MISSILE))
	and not (mo.player and mo.player.valid)
		return true
	end
	return false
end

local MAXHP = 100 --Maximum hp for all enemies/bosses
addHook("MobjSpawn", function(mo)
	if mo and mo.valid
	and DoHPCheck(mo)
		mo.fullenemyhp = mo.health-1
		mo.enemyhp = MAXHP
	end
end)
rawset(_G,"TTE_Enemies",{})

addHook("MobjDamage", function(mobj, mo, src, dmg, dmgtype)
	if mobj and mobj.valid
	and mobj.health
	and DoHPCheck(mobj,true) --If right enemy type and has health.
	and not (dmgtype & DMG_DEATHMASK) --If not fatal damage.
	and mobj.enemyhp
		if mo and mo.valid
		and (mo.type == MT_WRENCHHITBOX
		or (mo.type == MT_JETTBULLET and mo.target and mo.target.valid and mo.target.type == MT_BUILDSENTRY))
			local dmge = 25
			if mo.type == MT_WRENCHHITBOX dmge = 25 end
			if mo.type == MT_JETTBULLET dmge = 50 end
			dmge = $*dmg
			if mobj.enemydamage
				return true
			else
				if dmge
					local dmgnum = {
					[25] = S_DAMAGE_25,
					[50] = S_DAMAGE_50}
					if dmgnum[dmge]
						local d = P_SpawnMobjFromMobj(mobj,0,0,mobj.height,MT_SCORE)
						P_SetObjectMomZ(d,2*FRACUNIT)
						d.state = dmgnum[dmge]
					end
				end
				
				--print(tostring(mobj)..": ".."\x83"..mobj.enemyhp)
				--print(tostring(mobj)..": ".."\x85"..max(mobj.enemyhp-dmge,0))
				--if max(mobj.enemyhp - dmge,0)
					mobj.enemydamage = 7
					mobj.enemyhp = $ - dmge
					if mobj.target and mobj.target.valid
						mobj.lasttarget = mobj.target
					end
					S_StartSound(mobj, sfx_cybdth)
					AddToTable(mobj,TTE_Enemies)
					if (mobj.flags & MF_NOTHINK)
						mobj.hadnothink = true
					end
					mobj.flags = $|MF_NOTHINK
					
					if mobj.enemyhp <= 0
						if mobj.fullenemyhp and max(mobj.fullenemyhp,0)
							mobj.fullenemyhp = $ - 1
							mobj.enemyhp = MAXHP
						end
						local isboss = (mobj.flags & MF_BOSS)
						if isboss then isboss = (mobj.health - 1) == mobj.info.damage end
						if (mobj.health - 1) > 1
						and not isboss
							mobj.health = $-1
						else
							AddToTable(mobj,TTE_Enemies)
							if not mobj.hadnothink
								mobj.flags = $&~MF_NOTHINK
							end
							mobj.hadnothink = false
							return false
						end
					end
					return true
				/*else --Damage is big enough then actually damage the enemy
					if mobj.fullenemyhp and max(mobj.fullenemyhp,0)
						mobj.fullenemyhp = $ - 1
						mobj.enemyhp = MAXHP
					else
						mobj.fullenemyhp = 0
						mobj.enemyhp = 0
					end
					mobj.colorized = false
					if mobj.prevcolordam
						mobj.color = mobj.prevcolordam
					end
					AddToTable(mobj,TTE_Enemies)
					return false*/
				--end
			end
		end
	end
end)
addHook("MapLoad", do
	TTE_Enemies = {}
end)
addHook("ThinkFrame", do --Enemy flashing. Yes, I know MF2_FRET exists.
	for i,k in pairs(TTE_Enemies)
		local mo = TTE_Enemies[i]
		if not (mo and mo.valid and DoHPCheck(mo))
			table.remove(TTE_Enemies,i)
		end
		if mo.enemydamage
			if not mo.stopendam
				if mo.color
					mo.prevcolordam = mo.color
					mo.setnone = false
				else
					mo.setnone = true
				end
				if mo.colorized
					mo.wascolorized = true
				else
					mo.wascolorized = false
				end
			end
			mo.enemydamage = $-1
			mo.target = nil
			mo.movedir = -1
			
			if (mo.enemydamage&1)
				mo.colorized = true
				mo.color = SKINCOLOR_DAMAGED
			else
				mo.colorized = false
				if mo.prevcolordam
					mo.color = mo.prevcolordam
				end
				if mo.setnone
					mo.color = SKINCOLOR_NONE
				end
			end
			mo.stopendam = true
		elseif mo.stopendam
			if not mo.wascolorized
				mo.colorized = false
			end
			if mo.prevcolordam
				mo.color = mo.prevcolordam
			end
			if mo.setnone
				mo.color = SKINCOLOR_NONE
			end
			if mo.lasttarget and mo.lasttarget.valid
				mo.target = mo.lasttarget
			end
			mo.stopendam = false
			if not mo.hadnothink
				mo.flags = $&~MF_NOTHINK
			end
			mo.hadnothink = false
			table.remove(TTE_Enemies,i)
		end
	end
end)

addHook("MobjDeath", function(mo)
	if mo and mo.valid
	and DoHPCheck(mo)
		mo.colorized = false
		if mo.prevcolordam
			mo.color = mo.prevcolordam
		end
		if mo.lasttarget and mo.lasttarget.valid
			mo.target = mo.lasttarget
		end
		if not mo.hadnothink
			mo.flags = $&~MF_NOTHINK
		end
		mo.hadnothink = false
	end
end)